package ru.ldeloff.servermonitorbot.utils.ui.uname;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import org.telegram.telegrambots.meta.api.objects.replykeyboard.InlineKeyboardMarkup;
import org.telegram.telegrambots.meta.api.objects.replykeyboard.buttons.InlineKeyboardButton;
import ru.ldeloff.servermonitorbot.repository.SshRepository;
import ru.ldeloff.servermonitorbot.utils.ui.UiFormer;

import java.util.ArrayList;
import java.util.List;

@Component
public class UnameChatButtonAggregate implements UiFormer {

    private final SshRepository sshRepository;

    @Autowired
    public UnameChatButtonAggregate(SshRepository sshRepository) {
        this.sshRepository = sshRepository;
    }

    @Override
    public SendMessage uiForm(SendMessage message) {
        List<List<InlineKeyboardButton>> keyboard = new ArrayList<>();

        InlineKeyboardMarkup inlineKeyboardMarkup = new InlineKeyboardMarkup();

        sshRepository.getSshServers().forEach(sshServer -> {
            List<InlineKeyboardButton> keyboardRow = new ArrayList<>();
            InlineKeyboardButton inlineKeyboardButton = new InlineKeyboardButton();
            inlineKeyboardButton.setText(sshServer.getName());
            inlineKeyboardButton.setCallbackData("uname: " + sshServer.getName());
            keyboardRow.add(inlineKeyboardButton);
            keyboard.add(keyboardRow);
        });
        List<InlineKeyboardButton> keyboardRow = new ArrayList<>();
        InlineKeyboardButton inlineKeyboardButton = new InlineKeyboardButton();
        inlineKeyboardButton.setText("Все сервера");
        inlineKeyboardButton.setCallbackData("uname: all");
        keyboardRow.add(inlineKeyboardButton);
        keyboard.add(keyboardRow);

        inlineKeyboardMarkup.setKeyboard(keyboard);
        message.setReplyMarkup(inlineKeyboardMarkup);

        return message;
    }
}
